"""
ASGI config for muzak project.

It exposes the ASGI callable as a module-level variable named ``application``.

For more information on this file, see
https://docs.djangoproject.com/en/4.2/howto/deployment/asgi/
"""

import os
from django.core.asgi import get_asgi_application
from channels.routing import ProtocolTypeRouter, URLRouter
from channels.auth import AuthMiddlewareStack
from muzak.auth import QueryAuthMiddleware
import voting.routing

os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'muzak.settings')

application = ProtocolTypeRouter({
    "http": get_asgi_application(),
    "websocket": QueryAuthMiddleware(
        URLRouter(
            voting.routing.websocket_urlpatterns
        )
    ),
})
